## seqan3 3.3.0~rc.1+ds

=== submodules/sdsl-lite/test/header/CMakeLists.txt ===
# Modified version from Bio-Formats
# https://github.com/openmicroscopy/bioformats/blob/d3bb33eeda23e81f78fd25f658bfc14a4363805f/cpp/cmake/HeaderTest.cmake#L81-L113
# and SeqAn3
# https://github.com/seqan/seqan3/blob/c9719852dc2d42cd371bd5c65d3af93935f29f39/test/header/CMakeLists.txt
add_gtest()
add_library (sdsl_test_header INTERFACE)
set (header_all_target "sdsl_header_test")

file(GLOB SDSL_HEADER_ALL ${CMAKE_CURRENT_LIST_DIR}/../../include/sdsl/*.hpp)

file (WRITE "${CMAKE_CURRENT_BINARY_DIR}/${header_all_target}.cpp" "int main() {}")
add_executable (${header_all_target} ${CMAKE_CURRENT_BINARY_DIR}/${header_all_target}.cpp)
target_link_libraries (${header_all_target} "gtest_main" "gtest")
target_link_libraries (${header_all_target} sdsl_test_header)
add_test (NAME "header/${header_all_target}" COMMAND ${header_all_target})

include_directories(${CMAKE_CURRENT_LIST_DIR}/../../include
                    ${gtest_dir}/googletest/include
)

foreach (header ${SDSL_HEADER_ALL})
    foreach (repeat 1 2)
        get_filename_component (header_target_name "${header}" NAME_WE)
        set (header_target_name "${header_target_name}-${repeat}")
        set (header_target_source "${CMAKE_CURRENT_BINARY_DIR}/${header_target_name}.cpp")
        set (header_target "${header_all_target}--${header_target_name}")

        string (REPLACE "-" "__" header_test_name_safe "${header_all_target}, ${header_target}")
        file (WRITE "${header_target_source}" "
#include <${header}>
#include <${header}>
#include <gtest/gtest.h>
TEST(${header_test_name_safe}) {}")
        add_library (${header_target} OBJECT "${header_target_source}")
        link_libraries(gtest)
        if (CMAKE_VERSION VERSION_LESS 3.12)
            target_compile_options (${header_target} PRIVATE $<TARGET_PROPERTY:sdsl_test_header,INTERFACE_COMPILE_OPTIONS>)
            target_compile_definitions (${header_target} PRIVATE $<TARGET_PROPERTY:sdsl_test_header,INTERFACE_COMPILE_DEFINITIONS>)
            target_include_directories (${header_target} PRIVATE $<TARGET_PROPERTY:sdsl_test_header,INTERFACE_INCLUDE_DIRECTORIES>)
            # target_link_libraries (${header_target} PRIVATE $<TARGET_PROPERTY:sdsl_test_header,INTERFACE_LINK_LIBRARIES>)
        else ()
            target_link_libraries (${header_target} sdsl_test_header)
        endif ()
        target_sources (${header_all_target} PRIVATE $<TARGET_OBJECTS:${header_target}>)
    endforeach ()
endforeach ()

=== debian/changelog ===
seqan3 (3.3.0~rc.1+ds-3) unstable; urgency=medium

  * Release 3.3.0 RC1 to unstable with GCC 13 fixes. Closes: #1041371

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Jul 2023 12:49:27 +0200

seqan3 (3.3.0~rc.1+ds-2) experimental; urgency=medium

  * d/rules: nope, doc tests aren't ready yet.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 18 Jul 2023 12:23:25 +0200

seqan3 (3.3.0~rc.1+ds-1) experimental; urgency=medium

  * d/copyright: update excludes (range-v3 no longer used; doxygen-
    awecome added)
  * New upstream version
  * d/patches: refresh; dropped 2 applied upstream
  * d/rules: do the doc tests again

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 17 Jul 2023 19:04:40 +0200

seqan3 (3.2.0+ds-7) unstable; urgency=medium

  * Adopt debian/patches/better_gtest_benchmark_finding from upstream
  * debian/watch: grab the complete sources.
  * Refresh patch from upstream to cope with newer GCC 12 & 13.
    Closes: #1039561
  * Standards-Version: 4.6.2 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 11 Jul 2023 18:45:42 +0200

=== debian/control ===
Source: seqan3
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               ninja-build,
               zlib1g-dev <!nocheck>,
               libbz2-dev <!nocheck>,
               libboost-dev <!nocheck>,
               libgtest-dev <!nocheck>,
               libcereal-dev <!nocheck>,
               libbenchmark-dev <!nocheck>,
               liblemon-dev <!nocheck>,
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               cppreference-doc-en-html <!nodoc>,
               texlive-latex-base <!nodoc>,
               ghostscript <!nodoc>,
               texlive-latex-extra <!nodoc>,
               doxygen-awesome-css <!nodoc>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/seqan3
Vcs-Git: https://salsa.debian.org/med-team/seqan3.git
Homepage: https://www.seqan.de/
Rules-Requires-Root: no

Package: libseqan3-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends},
         zlib1g-dev,
         libbz2-dev,
         libcereal-dev
Description: C++ library for the analysis of biological sequences v3 (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files.

Package: seqan3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, doxygen-awesome-css
Suggests: libseqan3-dev
Description: C++ library for the analysis of biological sequences v3 (documentation)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the documentation and examples

=== debian/tests/control ===
Tests: run-tests
Depends: @, gcc, g++, cmake, libboost-dev, libgtest-dev, liblemon-dev, quilt, zlib1g-dev, libbz2-dev, libbenchmark-dev, dpkg-dev
# update debian/{control,rules,tests/run-tests} as well, when changing these
Restrictions: allow-stderr, skippable

## seqan3 3.3.0~rc.2+ds

=== submodules/sdsl-lite/test/CMakeLists.txt ===
set (sdsl_test_targets "")
set (generated_files "")

## Create targets to downloads file specified in download.config
include (download_files.cmake)
add_gtest ()
## Generate targets for special inputs
function (generate_target_for_special_inputs tc_name abs_tc_name)
    set (int_vec_regex "int-vec\\.[0-9]+\\.[0-9]+\\..+")
    set (bit_vec_regex "bit-vec\\.*")
    set (int_vec_sa_regex "int-vec-sa\\.[0-9]+\\.[0-9]+\\..+")

    if ("${tc_name}" MATCHES "${int_vec_regex}" OR ${tc_name} MATCHES "${bit_vec_regex}")
        if ("${tc_name}" MATCHES "${int_vec_regex}")
            string (REPLACE "int-vec." "" tc_suf ${tc_name})
            string (REPLACE "." ";" tc_param ${tc_suf}) #  insert semicolons to get a list :)
        else ()
            string (REPLACE "bit-vec." "" tc_param ${tc_name})
        endif ()
        add_custom_command (OUTPUT ${abs_tc_name}
                            COMMAND $<TARGET_FILE:bit_vector_generator> ${abs_tc_name} ${tc_param}
                            DEPENDS bit_vector_generator
                            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                            COMMENT "Generating test case ${tc_name}."
                            VERBATIM)
        set (generated_files
             ${generated_files} ${abs_tc_name}
             PARENT_SCOPE)
    endif ()

    if ("${tc_name}" MATCHES "${int_vec_sa_regex}")
        string (REPLACE "int-vec-sa." "" tc_suf ${tc_name})
        string (REPLACE "." ";" tc_param ${tc_suf}) #  insert semicolons to get a list :)
        add_custom_command (OUTPUT ${abs_tc_name}
                            COMMAND $<TARGET_FILE:int_vector_generator> ${abs_tc_name} ${tc_param}
                            COMMAND $<TARGET_FILE:replace_int_vector_value> ${abs_tc_name} 0 1
                            DEPENDS int_vector_generator replace_int_vector_value
                            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                            COMMENT "Generating test case ${tc_name}."
                            VERBATIM)
        set (generated_files
             ${generated_files} ${abs_tc_name}
             PARENT_SCOPE)
    endif ()
endfunction (generate_target_for_special_inputs)

## Get all headers of the library, include the headers into compile_test.cpp.
## Compiling the created target will check for obvious errors.
file (GLOB SDSL_HEADER_ALL RELATIVE ${sdsl_include_directory} ${sdsl_include_directory}/sdsl/*.hpp)
string (REGEX REPLACE "([^;]+)[;]" "#include \<\\1\>\\n" SDSL_INCLUDE_ALL "${SDSL_HEADER_ALL};")
configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/compile_test.cpp.cmake" "${CMAKE_CURRENT_SOURCE_DIR}/compile_test.cpp"
                @ONLY)

## Test sources are all files which ends with the suffix `_test.cpp`
## The following command will store all matching files in the variable `test_sources`
file (GLOB test_sources ${CMAKE_CURRENT_SOURCE_DIR}/*_test.cpp)

## Add required directionaries
include_directories (${sdsl_include_directory})
include_directories (SYSTEM ${gtest_dir}/googletest/include)

link_libraries ("gtest_main" "gtest")

if (SDSL_CEREAL)
    # Include via -isystem suppresses warnings of external dependencies in cereal
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isystem${CMAKE_CURRENT_SOURCE_DIR}/../external/cereal/include")
endif (SDSL_CEREAL)

add_executable (int_vector_generator int_vector_generator.cpp)
add_executable (bit_vector_generator bit_vector_generator.cpp)
add_executable (replace_int_vector_value replace_int_vector_value.cpp)

set (tmp_dirs "${CMAKE_CURRENT_LIST_DIR}/tmp/" "@/")
set (tmp_dirs_suffix "" "-im")

foreach (test_source ${test_sources})
    get_filename_component (test_name_we ${test_source} NAME_WE)

    string (REGEX REPLACE "_" "-" test_name_hy ${test_name_we})

    add_executable (${test_name_we} ${test_name_we}.cpp)
    list (APPEND sdsl_test_targets ${test_name_we})

    string (REGEX REPLACE "_[0-9]_" "_" config_name ${test_name_we})
    set (config_file ${CMAKE_CURRENT_SOURCE_DIR}/${config_name}.config)

    foreach (d RANGE 0 1)
        list (GET tmp_dirs ${d} tmp_dir)
        list (GET tmp_dirs_suffix ${d} tmp_dir_suffix)

        set (test_name "${test_name_hy}${tmp_dir_suffix}")

        # (1) Handle tests without .config file
        if (NOT EXISTS ${config_file})
            add_custom_target (${test_name}
                               COMMAND $<TARGET_FILE:${test_name_we}> ${tmp_dir}
                               DEPENDS test/${test_name_we} ${test_name_we}
                               WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                               COMMENT "Execute ${test_name}.")

            add_test (NAME ${test_name}
                      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                      COMMAND $<TARGET_FILE:${test_name_we}> ${tmp_dir})
            # (2) Handle tests with .config file
        else ()
            set (test_targets "")
            file (STRINGS ${config_file} config_lines REGEX "^[^#].+")
            set (config_line_cnt 0)
            foreach (config_line ${config_lines})
                math (EXPR config_line_cnt ${config_line_cnt}+1)
                # (2.1) Handle tests with one file per line in the .config file
                #       This is true if there is no semi-colon in the line (checked in the next line)
                if ("${config_line}" MATCHES "^[^;]+$")
                    get_filename_component (test_case_name ${config_line} NAME)
                    set (abs_test_case_name ${CMAKE_CURRENT_LIST_DIR}/test_cases/${test_case_name})

                    generate_target_for_special_inputs (${test_case_name} ${abs_test_case_name})

                    set (test_target ${test_name}_${test_case_name})
                    add_custom_target (${test_target}
                                       COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${tmp_dir}
                                       DEPENDS ${abs_test_case_name} ${test_name_we}
                                       WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                       COMMENT "Execute ${test_name} on ${test_case_name}.")
                    add_test (NAME ${test_target}
                              WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                              COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${tmp_dir})
                    # (2.1) Handle tests with multiple files per line in the .config file
                else ()
                    #               Handle Cs[a|t]IntTest
                    if ("${test_name_we}" MATCHES "cs[a|t]_int_test")
                        list (GET config_line 0 test_case_name)
                        set (abs_test_case_name ${CMAKE_CURRENT_LIST_DIR}/test_cases/${test_case_name})

                        generate_target_for_special_inputs (${test_case_name} ${abs_test_case_name})

                        list (GET config_line 1 num_byte)
                        set (test_target ${test_name}_${test_case_name}_${num_byte})
                        add_custom_target (${test_target}
                                           COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${num_byte}
                                                   ${tmp_dir}
                                           DEPENDS ${abs_test_case_name} ${test_name_we}
                                           WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                           COMMENT "Execute ${test_name} on ${test_case_name}.")

                        add_test (NAME ${test_target}
                                  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                  COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${num_byte} ${tmp_dir})
                        list (APPEND test_targets ${test_target})
                        #               Handle K2TreapTest
                    elseif ("${test_name_we}" MATCHES "k2_treap_test")
                        set (concat_config "")
                        foreach (item ${config_line})
                            set (concat_config "${conact_config}${item}")
                        endforeach (item)
                        set (k2dim x y w)
                        list (GET config_line 0 test_case_name)
                        set (test_case_name "k2-${concat_config}")
                        if (NOT TARGET ${test_case_name})
                            set (abs_test_case_name ${CMAKE_CURRENT_LIST_DIR}/test_cases/${test_case_name})
                            set (abs_test_case_name_list "")
                            foreach (i 0 1 2)
                                list (GET k2dim ${i} dim)
                                set (local_abs_test_case_name ${abs_test_case_name}.${dim})
                                list (APPEND abs_test_case_name_list ${local_abs_test_case_name})
                                list (GET config_line ${i} test_case_suf)
                                string (REPLACE "." ";" test_case_param ${test_case_suf})
                                add_custom_command (OUTPUT ${local_abs_test_case_name}
                                                    COMMAND $<TARGET_FILE:int_vector_generator>
                                                            ${local_abs_test_case_name} ${test_case_param}
                                                    DEPENDS int_vector_generator
                                                    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                                    COMMENT "Generating test case ${test_case_name}."
                                                    VERBATIM)
                                set (generated_files ${generated_files} ${local_abs_test_case_name})
                            endforeach (i)
                            add_custom_target (${test_case_name} DEPENDS ${abs_test_case_name_list})
                        endif ()
                        set (test_target ${test_name}_${test_case_name})
                        add_custom_target (${test_target}
                                           COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${tmp_dir}
                                           DEPENDS ${test_case_name} ${test_name_we}
                                           WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                                           COMMENT "Execute ${test_name} on ${test_case_name}.")
                        add_test (NAME ${test_target}
                                  COMMAND $<TARGET_FILE:${test_name_we}> ${abs_test_case_name} ${tmp_dir}
                                  WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
                        list (APPEND test_targets ${test_target})
                    endif ()
                endif ()
            endforeach (config_line)

            add_custom_target (${test_name} DEPENDS ${test_targets})
        endif ()
    endforeach (d)
endforeach (test_source)

list (REMOVE_DUPLICATES generated_files)
add_custom_target (generate_test_files ALL DEPENDS ${generated_files})
add_custom_target (sdsl_test_targets DEPENDS ${sdsl_test_targets} ${generated_files})
add_custom_target (clean-test
                   COMMAND ${CMAKE_COMMAND} -E remove -f ${generated_files}
                   COMMENT "Remove generated test inputs.")

=== test/performance/search/dream_index/CMakeLists.txt ===
seqan3_benchmark (interleaved_bloom_filter_benchmark.cpp)

=== test/unit/alphabet/nucleotide/CMakeLists.txt ===
seqan3_test (dna4_test.cpp)
seqan3_test (dna5_test.cpp)
seqan3_test (dna15_test.cpp)
seqan3_test (dna16sam_test.cpp)
seqan3_test (dna3bs_test.cpp)
seqan3_test (rna4_test.cpp)
seqan3_test (rna5_test.cpp)
seqan3_test (rna15_test.cpp)
seqan3_test (nucleotide_conversion_integration_test.cpp)
seqan3_test (simd_dna4_test.cpp)

=== debian/changelog ===
seqan3 (3.3.0~rc.2+ds-1) unstable; urgency=medium

  * New upstream version
  * d/patches: drop debian_cppreference and set
    SEQAN3_DOXYGEN_STD_TAGFILE instead, thanks to upstream adapting
    their buildsystem.
  * d/patches: remove better_gtest_benchmark_finding; upstream does a
    better job of accepting a system install of gtest & benchmark.
  * d/control: set the -doc package to not be apart of the the nodoc
    build profile

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 10 Aug 2023 10:09:07 +0200

## seqan3 3.3.0%2Bds

=== CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

# This file provides functionality common to the different test modules used by
# SeqAn3. To build tests, run cmake on one of the sub-folders in this directory
# which contain a CMakeLists.txt.

cmake_minimum_required (VERSION 3.4)

find_path (SEQAN3_MODULE_PATH "seqan3-config.cmake" HINTS "${CMAKE_CURRENT_LIST_DIR}/build_system/")
list (APPEND CMAKE_MODULE_PATH "${SEQAN3_MODULE_PATH}")

include (seqan3-config-version)

if (CMAKE_VERSION VERSION_LESS 3.12)
    project (seqan3
             LANGUAGES CXX
             VERSION "${SEQAN3_PROJECT_VERSION}")
else ()
    project (seqan3
             LANGUAGES CXX
             VERSION "${SEQAN3_PROJECT_VERSION}"
             DESCRIPTION "SeqAn3 -- the modern C++ library for sequence analysis" # since cmake 3.9
             HOMEPAGE_URL "https://github.com/seqan/seqan3" # since cmake 3.12
    )
endif ()

find_package (SeqAn3 3.0 REQUIRED HINTS ${SEQAN3_MODULE_PATH})

option (INSTALL_SEQAN3 "Enable installation of seqan3. (Projects embedding seqan3 may want to turn this OFF.)" ON)

if (INSTALL_SEQAN3)
    include (seqan3-install)
    include (seqan3-package)
endif ()

=== test/coverage/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.10...3.22)
project (seqan3_test_coverage CXX)

include (../seqan3-test.cmake)

if (CMAKE_BUILD_TYPE AND NOT ("${CMAKE_BUILD_TYPE}" STREQUAL "Debug"))
    message (WARNING "Coverage test must be build in debug mode [build type = ${CMAKE_BUILD_TYPE}]")
endif ()

find_program (GCOVR_COMMAND NAMES gcovr)

if (NOT GCOVR_COMMAND)
    message (FATAL_ERROR "gcovr not found! Aborting...")
endif ()

# Holds all target's defined by seqan3_test
set_property (GLOBAL PROPERTY GLOBAL_TEST_COVERAGE_ALL_TESTS "")

set (SEQAN3_COVERAGE_PARALLEL_LEVEL
     "1"
     CACHE STRING "Number of threads to use for coverage report generation.")

set (SEQAN3_GCOVR_ARGUMENTS "")

macro (seqan3_append_gcovr_args)
    set (key ${ARGV0})
    if (${ARGC} EQUAL 1)
        list (APPEND SEQAN3_GCOVR_ARGUMENTS ${key})
    else ()
        string (REPLACE "'^" "\\''^" value "${ARGV1}")
        string (REPLACE "$'" "$$'\\'" value "${value}")
        string (REPLACE ";" "\\\\\\;" value "${value}")
        list (APPEND SEQAN3_GCOVR_ARGUMENTS ${key} ${value})
    endif ()
endmacro ()

# Arguments for gcovr.
# Certain chracters will be escaped by seqan3_append_gcovr_args.
# Special CMake characters such as "\" must be escaped manually with "\\".
# We can prevent one level of CMake's string evaluation by using bracket arguments, which are similar to raw strings:
# (https://cmake.org/cmake/help/latest/manual/cmake-language.7.html#bracket-argument)
# gcovr uses python regex expressions.
# See https://gcovr.com/en/5.0/guide.html#the-gcovr-command for an overview of parameters.
# See https://gcovr.com/en/5.0/faq.html#why-does-c-code-have-so-many-uncovered-branches for an explanation on branches.

# The directory of the CMakeLists.txt used for invoking cmake.
seqan3_append_gcovr_args ("--root" "${CMAKE_CURRENT_LIST_DIR}")
# The build directory.
seqan3_append_gcovr_args ("${PROJECT_BINARY_DIR}")
# Include all files whose path match '${SEQAN3_CLONE_DIR}/include/seqan3/.*'.
seqan3_append_gcovr_args ("--filter" "${SEQAN3_CLONE_DIR}/include/seqan3")
# Include all files whose path match '${SEQAN3_CLONE_DIR}/test/include/seqan3/test/.*'.
seqan3_append_gcovr_args ("--filter" "${SEQAN3_CLONE_DIR}/test/include/seqan3/test")
# Remove all files whose path match '${SEQAN3_CLONE_DIR}/include/seqan3/contrib/.*'.
seqan3_append_gcovr_args ("--exclude" "${SEQAN3_CLONE_DIR}/include/seqan3/contrib")
# Remove all files whose path match '${SEQAN3_CLONE_DIR}/include/seqan3/std/.*'.
seqan3_append_gcovr_args ("--exclude" "${SEQAN3_CLONE_DIR}/include/seqan3/std")
# Remove line coverage for all lines that match '^\s*$', i.e. empty lines.
seqan3_append_gcovr_args ("--exclude-lines-by-pattern" [['^\\s*$']])
# Remove line coverage for all lines that match "^\s*[{}]{0,2}\s*;*\s*(//.*)?$", i.e. lines with a single '{' or '}'
# or a combination of those (max 2) which might be followed by a semicolon or a comment '//'.
seqan3_append_gcovr_args ("--exclude-lines-by-pattern" [['^\\s*[{}]{0,2}\\s*;*\\s*(//.*)?$']])
# Will exclude branches that are unreachable.
seqan3_append_gcovr_args ("--exclude-unreachable-branches")
# Will exclude branches that are only generated for exception handling.
seqan3_append_gcovr_args ("--exclude-throw-branches")
# Will exclude non-code lines, e.g. lines with closing braces.
seqan3_append_gcovr_args ("--exclude-noncode-lines")
# Run up to this many gcov instances in parallel.
seqan3_append_gcovr_args ("-j" "${SEQAN3_COVERAGE_PARALLEL_LEVEL}")

add_custom_command (OUTPUT ${PROJECT_BINARY_DIR}/seqan3_coverage.xml
                    # Run tests.
                    COMMAND ${CMAKE_CTEST_COMMAND} -j ${SEQAN3_COVERAGE_PARALLEL_LEVEL} --output-on-failure
                    # Run gcovr and create XML report.
                    COMMAND ${GCOVR_COMMAND} ${SEQAN3_GCOVR_ARGUMENTS} --xml --output
                            ${PROJECT_BINARY_DIR}/seqan3_coverage.xml
                    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
                    COMMENT "Processing code coverage counters and generating XML report."
                    COMMAND_EXPAND_LISTS)

add_custom_target (coverage ALL DEPENDS ${PROJECT_BINARY_DIR}/seqan3_coverage.xml)

add_custom_command (OUTPUT ${PROJECT_BINARY_DIR}/html/index.html
                    # Run tests.
                    COMMAND ${CMAKE_CTEST_COMMAND} -j ${SEQAN3_COVERAGE_PARALLEL_LEVEL} --output-on-failure
                    # Create output directory.
                    COMMAND ${CMAKE_COMMAND} -E make_directory ${PROJECT_BINARY_DIR}/html/
                    # Run gcovr and create HTML report.
                    COMMAND ${GCOVR_COMMAND} ${SEQAN3_GCOVR_ARGUMENTS} --html-details --output
                            ${PROJECT_BINARY_DIR}/html/index.html
                    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
                    COMMENT "Processing code coverage counters and generating HTML report."
                    COMMAND_EXPAND_LISTS)

add_custom_target (coverage_html
                   DEPENDS ${PROJECT_BINARY_DIR}/html/index.html
                   COMMENT "Generate coverage report.")

add_custom_command (TARGET coverage_html
                    POST_BUILD
                    COMMAND ;
                    COMMENT "Open ${PROJECT_BINARY_DIR}/html/index.html in your browser to view the coverage report.")

macro (seqan3_test unit_test_cpp)
    file (RELATIVE_PATH unit_test "${CMAKE_SOURCE_DIR}/../unit" "${CMAKE_CURRENT_LIST_DIR}/${unit_test_cpp}")
    seqan3_test_component (target "${unit_test}" TARGET_NAME)
    seqan3_test_component (test_name "${unit_test}" TEST_NAME)

    add_executable (${target} ${unit_test_cpp})
    target_link_libraries (${target} seqan3::test::coverage)
    add_test (NAME "${test_name}" COMMAND ${target})

    # any change of a target will invalidate the coverage result;
    # NOTE that this is a GLOBAL variable, because a normal
    # `set(GLOBAL_TEST_COVERAGE_ALL_TESTS)` would not propagate the result when
    # CMakeLists.txt goes out of scope due to a `add_subdirectory`
    set_property (GLOBAL APPEND PROPERTY GLOBAL_TEST_COVERAGE_ALL_TESTS ${target})

    unset (unit_test)
    unset (target)
    unset (test_name)
endmacro ()

seqan3_require_ccache ()
seqan3_require_test ()

# add all unit tests
add_subdirectories_of ("${CMAKE_CURRENT_SOURCE_DIR}/../unit")

# add collected test cases as dependency
get_property (TEST_COVERAGE_ALL_TESTS GLOBAL PROPERTY GLOBAL_TEST_COVERAGE_ALL_TESTS)
add_custom_command (OUTPUT ${PROJECT_BINARY_DIR}/seqan3_coverage.xml
                    DEPENDS ${TEST_COVERAGE_ALL_TESTS}
                    APPEND)

=== test/external_project/seqan3_fetch_content_zip/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.14)
project (seqan3_app CXX)

# --- helper scripts
include (../find-package-diagnostics.cmake)
file (SHA256 "${SEQAN3_PACKAGE_ZIP_URL}" SEQAN3_PACKAGE_ZIP_HASH)
message (STATUS "SEQAN3_PACKAGE_ZIP_URL: ${SEQAN3_PACKAGE_ZIP_URL}")
message (STATUS "SEQAN3_PACKAGE_ZIP_HASH: SHA256=${SEQAN3_PACKAGE_ZIP_HASH}")
# ---

# fetch seqan3 sources (requires >= cmake 3.14)
include (FetchContent)
FetchContent_Declare (
    seqan3
    URL "${SEQAN3_PACKAGE_ZIP_URL}" # change these values
    URL_HASH "SHA256=${SEQAN3_PACKAGE_ZIP_HASH}" # change these values
)
FetchContent_MakeAvailable (seqan3)

# add seqan3 to search path
list (APPEND CMAKE_PREFIX_PATH "${seqan3_SOURCE_DIR}")

# require seqan3 with a version between >=3.0.0 and <4.0.0
find_package (seqan3 3.0 REQUIRED)

# build app with seqan3
add_executable (hello_world ../src/hello_world.cpp)
target_link_libraries (hello_world seqan3::seqan3)
install (TARGETS hello_world)

=== test/external_project/seqan3_installed/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.4)
project (seqan3_app CXX)

# --- helper scripts
include (../find-package-diagnostics.cmake)
# ---

# require seqan3 with a version between >=3.0.0 and <4.0.0
find_package (seqan3 3.0 REQUIRED)

# build app with seqan3
add_executable (hello_world ../src/hello_world.cpp)
target_link_libraries (hello_world seqan3::seqan3)
if (CMAKE_VERSION VERSION_LESS 3.14)
    install (TARGETS hello_world RUNTIME DESTINATION bin)
else ()
    install (TARGETS hello_world) # RUNTIME DESTINATION not needed anymore since cmake 3.14
endif ()

=== test/external_project/seqan3_setup_tutorial_with_sharg/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

# --- helper scripts
include (../find-package-diagnostics.cmake)
# ---

# Copy the cpp so we can use add_executable like in the tutorial
file (COPY "${CMAKE_SOURCE_DIR}/../src/hello_world.cpp" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file (RENAME "${CMAKE_CURRENT_BINARY_DIR}/hello_world.cpp" "${CMAKE_CURRENT_BINARY_DIR}/another_program.cpp")
file (COPY "${CMAKE_SOURCE_DIR}/../src/hello_world.cpp" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
# In the tutorial, the CMAKE_CURRENT_SOURCE_DIR is a sibling directory of the seqan3 checkout
set (CMAKE_CURRENT_SOURCE_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../source")
# Cannot replicate a Sharg checkout just like in the tutorial
list (APPEND CMAKE_PREFIX_PATH "${SHARG_ROOT}/build_system")

## [adding_files]
cmake_minimum_required (VERSION 3.4)
project (seqan3_tutorial CXX)

# add seqan3 to search path
list (APPEND CMAKE_PREFIX_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../seqan3/build_system")
# add the Sharg Parser to search path
list (APPEND CMAKE_PREFIX_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../sharg-parser/build_system")

# require seqan3 with a version between >=3.0.0 and <4.0.0
find_package (seqan3 3.0 REQUIRED)
find_package (sharg 1.0 REQUIRED)

# build app with seqan3
add_executable (hello_world hello_world.cpp)
target_link_libraries (hello_world seqan3::seqan3 sharg::sharg)

add_executable (another_program another_program.cpp)
target_link_libraries (another_program seqan3::seqan3 sharg::sharg)
## [adding_files]

if (CMAKE_VERSION VERSION_LESS 3.14)
    install (TARGETS hello_world another_program RUNTIME DESTINATION bin)
else ()
    install (TARGETS hello_world another_program) # RUNTIME DESTINATION not needed anymore since cmake 3.14
endif ()

=== test/external_project/seqan3_submodule_find_package/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.4)
project (seqan3_app CXX)

# --- helper scripts
include (../find-package-diagnostics.cmake)
# ---

# add seqan3 to search path
list (APPEND CMAKE_PREFIX_PATH "${CMAKE_CURRENT_SOURCE_DIR}/submodules/seqan3/build_system") # change this value

# require seqan3 with a version between >=3.0.0 and <4.0.0
find_package (seqan3 3.0 REQUIRED)

# build app with seqan3
add_executable (hello_world ../src/hello_world.cpp)
target_link_libraries (hello_world seqan3::seqan3)
if (CMAKE_VERSION VERSION_LESS 3.14)
    install (TARGETS hello_world RUNTIME DESTINATION bin)
else ()
    install (TARGETS hello_world) # RUNTIME DESTINATION not needed anymore since cmake 3.14
endif ()

=== test/performance/alphabet/CMakeLists.txt ===
add_subdirectories ()

seqan3_benchmark (alphabet_assign_char_benchmark.cpp)
seqan3_benchmark (alphabet_assign_rank_benchmark.cpp)
seqan3_benchmark (alphabet_complement_benchmark.cpp)
seqan3_benchmark (alphabet_to_char_benchmark.cpp)
seqan3_benchmark (alphabet_to_rank_benchmark.cpp)

=== test/unit/core/CMakeLists.txt ===
add_subdirectories ()

seqan3_test (add_enum_bitwise_operators_test.cpp)
seqan3_test (debug_stream_test.cpp)

=== test/unit/test/CMakeLists.txt ===
seqan3_test (expect_range_eq_test.cpp)
seqan3_test (expect_same_type_test.cpp)
seqan3_test (file_access_test.cpp)
seqan3_test (pretty_printing_test.cpp)
seqan3_test (sandboxed_path_test.cpp)
seqan3_test (seqan2_test.cpp)
seqan3_test (sequence_generator_test.cpp)
seqan3_test (tmp_directory_test.cpp)

=== test/performance/utility/bloom_filter/CMakeLists.txt ===
seqan3_benchmark (bloom_filter_benchmark.cpp)

=== test/unit/alignment/aligned_sequence/CMakeLists.txt ===
seqan3_test (debug_stream_alignment_test.cpp)

=== test/unit/alignment/cigar_conversion/CMakeLists.txt ===
seqan3_test (alignment_from_cigar_test.cpp)
seqan3_test (cigar_from_alignment_test.cpp)

=== debian/changelog ===
seqan3 (3.3.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 04 Sep 2023 18:14:20 +0200
